---
title: Introduction
slug: Web/JavaScript/Guide/Introduction
tags:
  - Beginner
  - Guide
  - Introduction
  - JavaScript
  - 'l10n:priority'
---
<div>{{jsSidebar("JavaScript Guide")}} {{PreviousNext("Web/JavaScript/Guide", "Web/JavaScript/Guide/Grammar_and_types")}}</div>

<p class="summary">This chapter introduces JavaScript and discusses some of its fundamental concepts.</p>

<h2 id="What_you_should_already_know">What you should already know</h2>

<p>This guide assumes you have the following basic background:</p>

<ul>
 <li>A general understanding of the Internet and the World Wide Web (<a href="/en-US/docs/Glossary/WWW">WWW</a>).</li>
 <li>Good working knowledge of HyperText Markup Language (<a href="/en-US/docs/Glossary/HTML">HTML</a>).</li>
 <li>Some programming experience. If you are new to programming, try one of the tutorials linked on the main page about <a href="/en-US/docs/Web/JavaScript">JavaScript</a>.</li>
</ul>

<h2 id="Where_to_find_JavaScript_information">Where to find JavaScript information</h2>

<p>The JavaScript documentation on MDN includes the following:</p>

<ul>
 <li><a href="/en-US/docs/Learn">Learn Web Development</a> provides information for beginners and introduces basic concepts of programming and the Internet.</li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide">JavaScript Guide</a> (this guide) provides an overview about the JavaScript language and its objects.</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference">JavaScript Reference</a> provides detailed reference material for JavaScript.</li>
</ul>

<p>If you are new to JavaScript, start with the articles in the <a href="/en-US/Learn">learning area</a> and the <a href="/en-US/docs/Web/JavaScript/Guide">JavaScript Guide</a>. Once you have a firm grasp of the fundamentals, you can use the <a href="/en-US/docs/Web/JavaScript/Reference">JavaScript Reference</a> to get more details on individual objects and statements.</p>

<h2 id="What_is_JavaScript">What is JavaScript?</h2>

<p>JavaScript is a cross-platform, object-oriented scripting language used to make webpages interactive (e.g., having complex animations, clickable buttons, popup menus, etc.).  There are also more advanced server side versions of JavaScript such as Node.js, which allow you to add more functionality to a website than downloading files (such as realtime collaboration between multiple computers). Inside a host environment (for example, a web browser), JavaScript can be connected to the objects of its environment to provide programmatic control over them.</p>

<p>JavaScript contains a standard library of objects, such as <code>Array</code>, <code>Date</code>, and <code>Math</code>, and a core set of language elements such as operators, control structures, and statements. Core JavaScript can be extended for a variety of purposes by supplementing it with additional objects; for example:</p>

<ul>
 <li><em>Client-side JavaScript</em> extends the core language by supplying objects to control a browser and its <em>Document Object Model</em> (DOM). For example, client-side extensions allow an application to place elements on an HTML form and respond to user events such as mouse clicks, form input, and page navigation.</li>
 <li><em>Server-side JavaScript</em> extends the core language by supplying objects relevant to running JavaScript on a server. For example, server-side extensions allow an application to communicate with a database, provide continuity of information from one invocation to another of the application, or perform file manipulations on a server.</li>
</ul>

<p>This means that in the browser, JavaScript can change the way the webpage (DOM) looks. And, likewise, Node.js JavaScript on the server can respond to custom requests from code written in the browser.</p>

<h2 id="JavaScript_and_Java">JavaScript and Java</h2>

<p>JavaScript and Java are similar in some ways but fundamentally different in some others. The JavaScript language resembles Java but does not have Java's static typing and strong type checking. JavaScript follows most Java expression syntax, naming conventions and basic control-flow constructs which was the reason why it was renamed from LiveScript to JavaScript.</p>

<p>In contrast to Java's compile-time system of classes built by declarations, JavaScript supports a runtime system based on a small number of data types representing numeric, Boolean, and string values. JavaScript has a prototype-based object model instead of the more common class-based object model. The prototype-based model provides dynamic inheritance; that is, what is inherited can vary for individual objects. JavaScript also supports functions without any special declarative requirements. Functions can be properties of objects, executing as loosely typed methods.</p>

<p>JavaScript is a very free-form language compared to Java. You do not have to declare all variables, classes, and methods. You do not have to be concerned with whether methods are public, private, or protected, and you do not have to implement interfaces. Variables, parameters, and function return types are not explicitly typed.</p>

<p>Java is a class-based programming language designed for fast execution and type safety. Type safety means, for instance, that you can't cast a Java integer into an object reference or access private memory by corrupting Java bytecodes. Java's class-based model means that programs consist exclusively of classes and their methods. Java's class inheritance and strong typing generally require tightly coupled object hierarchies. These requirements make Java programming more complex than JavaScript programming.</p>

<p>In contrast, JavaScript descends in spirit from a line of smaller, dynamically typed languages such as HyperTalk and dBASE. These scripting languages offer programming tools to a much wider audience because of their easier syntax, specialized built-in functionality, and minimal requirements for object creation.</p>

<table class="standard-table">
 <caption>JavaScript compared to Java</caption>
 <thead>
  <tr>
   <th scope="col">JavaScript</th>
   <th scope="col">Java</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Object-oriented. No distinction between types of objects. Inheritance is through the prototype mechanism, and properties and methods can be added to any object dynamically.</td>
   <td>Class-based. Objects are divided into classes and instances with all inheritance through the class hierarchy. Classes and instances cannot have properties or methods added dynamically.</td>
  </tr>
  <tr>
   <td>Variable data types are not declared (dynamic typing, loosely typed).</td>
   <td>Variable data types must be declared (static typing, strongly typed).</td>
  </tr>
  <tr>
   <td>Cannot automatically write to hard disk.</td>
   <td>Can automatically write to hard disk.</td>
  </tr>
 </tbody>
</table>

<p>For more information on the differences between JavaScript and Java, see the chapter <a href="/en-US/docs/Web/JavaScript/Guide/Details_of_the_Object_Model">Details of the object model</a>.</p>

<h2 id="JavaScript_and_the_ECMAScript_Specification">JavaScript and the ECMAScript specification</h2>

<p>JavaScript is standardized at <a class="external" href="https://www.ecma-international.org/">Ecma International</a> — the European association for standardizing information and communication systems (ECMA was formerly an acronym for the European Computer Manufacturers Association) to deliver a standardized, international programming language based on JavaScript. This standardized version of JavaScript, called ECMAScript, behaves the same way in all applications that support the standard. Companies can use the open standard language to develop their implementation of JavaScript. The ECMAScript standard is documented in the ECMA-262 specification. See <a href="/en-US/docs/Web/JavaScript/New_in_JavaScript">New in JavaScript</a> to learn more about different versions of JavaScript and ECMAScript specification editions.</p>

<p>The ECMA-262 standard is also approved by the <a class="external" href="https://www.iso.org/home.html">ISO</a> (International Organization for Standardization) as ISO-16262. You can also find the specification on <a class="external" href="https://www.ecma-international.org/publications/standards/Ecma-262.htm">the Ecma International website</a>. The ECMAScript specification does not describe the Document Object Model (DOM), which is standardized by the <a class="external" href="https://www.w3.org/">World Wide Web Consortium (W3C)</a> and/or <a href="https://whatwg.org">WHATWG (Web Hypertext Application Technology Working Group)</a>. The DOM defines the way in which HTML document objects are exposed to your script. To get a better idea about the different technologies that are used when programming with JavaScript, consult the article <a href="/en-US/docs/Web/JavaScript/JavaScript_technologies_overview">JavaScript technologies overview</a>.</p>

<h3 id="JavaScript_Documentation_versus_the_ECMAScript_Specification">JavaScript documentation versus the ECMAScript specification</h3>

<p>The ECMAScript specification is a set of requirements for implementing ECMAScript. It is useful if you want to implement standards-compliant language features in your ECMAScript implementation or engine (such as SpiderMonkey in Firefox, or V8 in Chrome).</p>

<p>The ECMAScript document is <em>not</em> intended to help script programmers. Use the JavaScript documentation for information when writing scripts.</p>

<p>The ECMAScript specification uses terminology and syntax that may be unfamiliar to a JavaScript programmer. Although the description of the language may differ in ECMAScript, the language itself remains the same. JavaScript supports all functionality outlined in the ECMAScript specification.</p>

<p>The JavaScript documentation describes aspects of the language that are appropriate for a JavaScript programmer.</p>

<h2 id="Getting_started_with_JavaScript">Getting started with JavaScript</h2>

<p>Getting started with JavaScript is easy: all you need is a modern Web browser. This guide includes some JavaScript features which are only currently available in the latest versions of Firefox, so using the most recent version of Firefox is recommended.</p>

<p>The <em>Web Console</em> tool built into Firefox is useful for experimenting with JavaScript; you can use it into two modes: single-line input mode, and multi-line input mode.</p>

<h3 id="Single-line_input_in_the_Web_Console">Single-line input in the Web Console</h3>

<p>The <a href="/en-US/docs/Tools/Web_Console">Web Console</a> shows you information about the currently loaded Web page, and also includes a JavaScript interpreter that you can use to execute JavaScript expressions in the current page.</p>

<p>To open the Web Console (<kbd>Ctrl</kbd>+<kbd>Shift</kbd>+<kbd>I</kbd> on Windows and Linux or <kbd>Cmd</kbd>-<kbd>Option</kbd>-<kbd>K</kbd> on Mac), open the <strong>Tools</strong> menu in Firefox, and select "<strong>Developer ▶ Web Console</strong>". </p>

<p>The Web Console appears at the bottom of the browser window. Along the bottom of the console is an input line that you can use to enter JavaScript, and the output appears in the panel above:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16569/2019-04-04_00-15-29.png"></p>

<p>The console works the exact same way as <code>eval</code>: the last expression entered is returned. For the sake of simplicity, it can be imagined that every time something is entered into the console, it is actually surrounded by <code>console.log</code> around <code>eval</code>, like so:</p>

<pre class="brush: js notranslate">function greetMe(yourName) {
  alert("Hello " + yourName)
}
<code>console.log(eval('3 + 5'))</code>
</pre>

<h3 id="Multi-line_input_in_the_Web_Console">Multi-line input in the Web Console</h3>

<p>The single-line input mode of the Web Console is great for quick testing of JavaScript expressions, but although you can execute multiple lines, it's not very convenient for that. For more complex JavaScript, you can use the <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter#Multi-line_mode">multi-line line input mode</a>.</p>

<h3 id="Hello_world">Hello world</h3>

<p>To get started with writing JavaScript, open the Web Console in multi-line mode, and write your first "Hello world" JavaScript code:</p>

<pre class="brush: js notranslate">(function(){
  "use strict";
  /* Start of your code */
  function greetMe(yourName) {
    alert('Hello ' + yourName);
  }

  greetMe('World');
  /* End of your code */
})();</pre>

<p>Press <kbd>Cmd</kbd>+<kbd>Enter</kbd> or <kbd>Ctrl</kbd>+<kbd>Enter</kbd> (or click the <strong>Run</strong> button) to watch it unfold in your browser!</p>

<p>In the following pages, this guide introduces you to the JavaScript syntax and language features, so that you will be able to write more complex applications.</p>

<p>But for now, remember to always include the <code>(function(){"use strict";</code> before your code, and add <code>})();</code> to the end of your code. You will learn <a href="/en-US/docs/Glossary/IIFE">what these mean</a>, but for now they can be thought of as doing the following:</p>

<ol>
 <li>Massively improve performance.</li>
 <li>Prevent semantics in JavaScript that trip up beginners.</li>
 <li>Prevent code snippets executed in the console from interacting with one-another (e.g., having something created in one console execution being used for a different console execution).</li>
</ol>

<p>{{PreviousNext("Web/JavaScript/Guide", "Web/JavaScript/Guide/Grammar_and_types")}}</p>
